unit UCommon;

interface

{$WARN SYMBOL_PLATFORM OFF}

uses
  Winapi.Windows, Winapi.CommCtrl, System.UITypes, System.Math.Vectors, System.SysUtils, Vcl.Dialogs;

function ShowChooseDialog(const Items: array of string): Integer;

function QuaternionInverse(const Q: TQuaternion3D): TQuaternion3D;

procedure OVR_DEBUG_LOG(const S: string); overload; inline;
procedure OVR_DEBUG_LOG(const Format: string; const Args: array of const); overload;

implementation

function ShowChooseDialog(const Items: array of string): Integer;
var
  i: NativeInt;
begin
  with TTaskDialog.Create(nil) do
  try
    Caption := 'OculusRoomTiny';
    Title := 'Choose demo';
    for i := Low(Items) to High(Items) do
      RadioButtons.Add.Caption := Items[i];
    if not Execute then Exit(-1);
    if ModalResult <> mrOk then Exit(-1);
    Result := RadioButton.Index;
  finally
    Free;
  end;
end;

function QuaternionInverse(const Q: TQuaternion3D): TQuaternion3D;
var
  LengthSq: Single;
begin
  LengthSq := Q.ImagPart.X * Q.ImagPart.X + Q.ImagPart.Y * Q.ImagPart.Y
    + Q.ImagPart.Z * Q.ImagPart.Z + Q.RealPart * Q.RealPart;
  Result.ImagPart.X := -Q.ImagPart.X / LengthSq;
  Result.ImagPart.Y := -Q.ImagPart.Y / LengthSq;
  Result.ImagPart.Z := -Q.ImagPart.Z / LengthSq;
  Result.RealPart := Q.RealPart / LengthSq;
end;

procedure OVR_DEBUG_LOG(const S: string);
begin
{$IFDEF DEBUG}
  OutputDebugString(PChar(S));
{$ENDIF}
end;

procedure OVR_DEBUG_LOG(const Format: string; const Args: array of const);
begin
{$IFDEF DEBUG}
  OVR_DEBUG_LOG(System.SysUtils.Format(Format, Args));
{$ENDIF}
end;

end.