unit UDemoYG;

interface

procedure Main;

implementation

uses
  Winapi.Windows, Winapi.D3D11, System.SysUtils, System.Math.Vectors,
  OVR_CAPI, UDirectXAppUtil, UBasicVR, UYgModels;

type
  TYGVR = class(TBasicVR)
  private
    FMirror: Boolean;
  public
    constructor Create;
    procedure MainLoop; override;
  end;

constructor TYGVR.Create;
begin
  inherited Create('YGVR');
  FMirror := True;
end;

procedure TYGVR.MainLoop;
const
  fBlack: TFourSingleArray = (0,0,0,0);
var
  eye: NativeInt;
  model1, model2, modelMob: TYgModel;
  models: array of TYgModel;
  m: TYgModel;

//  procedure RotateBone(Model: TYgModel; BoneIndex: Integer; Axis: TPoint3D; Angle: Single);
//  begin
//    Model.FBones[BoneIndex].Rotation := Model.FBones[BoneIndex].Rotation * TQuaternion3D.Create(Axis, Angle);
//  end;

begin
  Layer[0] := TVRLayer.Create(Session);

  modelMob := TYgModel.CreateMob('ct0001\ct0001.TMD', Point3D(-0.6, 0.0, -0.5), TQuaternion3D.Create(Pi,0,0));
  RoomScene.Models.Add(modelMob);

  models := models + [TYgModel.CreateNpc(98, Point3D(0.0, 0.0, -7.5), TQuaternion3D.Create(Pi,0,0))]; // 受
  models := models + [TYgModel.CreateNpc(46, Point3D(-5.0, 0.0, 2.0), TQuaternion3D.Create(Pi,0,0))]; // d
  models := models + [TYgModel.CreateNpc(40, Point3D(-4.0, 0.0, 2.0), TQuaternion3D.Create(Pi,0,0))]; // Θ@
  models := models + [TYgModel.CreateNpc(39, Point3D(-3.0, 0.0, 2.0), TQuaternion3D.Create(Pi,0,0))]; // @
  models := models + [TYgModel.CreateNpc(7, Point3D(-2.0, 0.0, 2.0), TQuaternion3D.Create(Pi,0,0))]; // rAJ
  models := models + [TYgModel.CreateNpc(2, Point3D(-1.0, 0.0, 2.0), TQuaternion3D.Create(Pi,0,0))]; // hV[
  models := models + [TYgModel.CreateNpc(32, Point3D(0.0, 0.0, 2.0), TQuaternion3D.Create(Pi,0,0))]; // `Ci

  model2 := TYgModel.CreateNpc(104, Point3D(1.0, 0.0, 2.0), TQuaternion3D.Create(Pi,0,0)); // Jsbg
  models := models + [model2];
  model1 := TYgModel.CreateNpc(111, Point3D(2.0, 0.0, 2.0), TQuaternion3D.Create(Pi,0,0)); // ii
  models := models + [model1];
  models := models + [TYgModel.CreateNpc(78, Point3D(3.0, 0.0, 2.0), TQuaternion3D.Create(Pi,0,0))]; // Ai
  models := models + [TYgModel.CreateNpc(110, Point3D(4.0, 0.0, 2.0), TQuaternion3D.Create(Pi,0,0))]; // T^Ai
  models := models + [TYgModelPC.Create(False, Point3D(0.0, 0.0, 3.0), TQuaternion3D.Create(Pi,0,0))]; // PC female

  for m in models do
    RoomScene.Models.Add(m);

  //frame := 0;
  while HandleMessages do
  begin
    ActionFromInput(1, True, True);
    if DIRECTX.KeyDown['M'] then
    begin
      FMirror := not FMirror;
      if not FMirror then
      begin
        DIRECTX.Context.ClearRenderTargetView(DIReCTX.BackBufferRT, fBlack);
        DIRECTX.SwapChain.Present(0, 0);
      end;
    end;

    //if DIRECTX.Key['N'] then
    //if frame = 0 then
    //begin
      modelMob.NextFrame;
    for m in models do
      m.NextFrame;
    //end;
    //frame := (frame + 1) mod 3;

    if DIRECTX.Key['R'] then
      ovr_RecenterTrackingOrigin(Session);

//    if DIRECTX.Key['Z'] then
//      RotateBone(model1, 6, Point3D(0,1,0), 0.01);
//    if DIRECTX.Key['C'] then
//      RotateBone(model1, 6, Point3D(0,1,0), -0.01);
//
//    if DIRECTX.Key['F'] then
//      RotateBone(model1, 53, Point3D(0,1,0), 0.01);
//    if DIRECTX.Key['G'] then
//      RotateBone(model1, 53, Point3D(0,1,0), -0.01);

    // PageUp,PageDown
//    if DIRECTX.Key[Chr(VK_PRIOR)] then
//    begin
//    end;
//    if DIRECTX.Key[Chr(VK_NEXT)] then
//    begin
//    end;

//    if DIRECTX.Key[Chr(VK_ADD)] then
//    begin
//    end;
//    if DIRECTX.Key[Chr(VK_SUBTRACT)] then
//    begin
//    end;

    Layer[0].GetEyePoses;

    RoomScene.Update;

    for eye := 0 to 1 do
    begin
      Layer[0].RenderSceneToEyeBuffer(MainCam, RoomScene, eye, nil, nil, 1, 1, 1, 1, 1, 0.01, 1000);
    end;

    Layer[0].PrepareLayerHeader;
    DistortAndPresent(1, nil, FMirror);
  end;
end;

procedure Test;
var
  m, mP, mC: TMatrix3D;
  s: string;
begin
  mP := TMatrix3D.Create(
    0.0000, 0.0000, 1.0000, 0.0000,
    0.0000, 1.0000, 0.0000, 0.0000,
    -1.0000, 0.0000, 0.0000, 0.0000,
    0.0000, 0.6284, 0.0425, 1.0000
  );
  mC := TMatrix3D.Create(
    0.0000, 1.0000, 0.0000, 0.0000,
    0.0000, 0.0000, 1.0000, 0.0000,
    1.0000, 0.0000, 0.0000, 0.0000,
    0.0000, 0.0000, 0.0000, 1.0000
  );

  //m := m2 * m1.Inverse;
  m := mC * mP;

  with m do
    s := Format(
      '%.4f,%.4f,%.4f,%.4f,'#13#10 +
      '%.4f,%.4f,%.4f,%.4f,'#13#10 +
      '%.4f,%.4f,%.4f,%.4f,'#13#10 +
      '%.4f,%.4f,%.4f,%.4f',
      [
        m11, m12, m13, m14,
        m21, m22, m23, m24,
        m31, m32, m33, m34,
        m41, m42, m43, m44
      ]);
  MessageBox(0, PChar(s), 'YGVR', MB_OK);
end;

procedure Main;
var
  app: TYGVR;
begin
//  Test;
//  Exit;

  app := TYGVR.Create;
  try
    ExitCode := app.Run;
  finally
    app.Free;
  end;
end;

end.