(********************************************************************************)(**
\file      OVR_Version.pas
\brief     This header provides LibOVR version identification.
\copyright Copyright 2014-2016 Oculus VR, LLC All Rights reserved.
*************************************************************************************)
unit OVR_Version;

interface

const
  // Master version numbers
  OVR_PRODUCT_VERSION = 1;  // Product version doesn't participate in semantic versioning.
  OVR_MAJOR_VERSION   = 1;  // If you change these values then you need to also make sure to change LibOVR/Projects/Windows/LibOVR.props in parallel.
  OVR_MINOR_VERSION   = 4;  // 
  OVR_PATCH_VERSION   = 0;
  OVR_BUILD_NUMBER    = 0;

  // This is the ((product * 100) + major) version of the service that the DLL is compatible with.
  // When we backport changes to old versions of the DLL we update the old DLLs
  // to move this version number up to the latest version.
  // The DLL is responsible for checking that the service is the version it supports
  // and returning an appropriate error message if it has not been made compatible.
  OVR_DLL_COMPATIBLE_VERSION = 101;

  OVR_FEATURE_VERSION = 0;


  /// "Major.Minor.Patch"
  OVR_VERSION_STRING = '1.4.0';


  /// "Major.Minor.Patch.Build"
  OVR_DETAILED_VERSION_STRING = '1.4.0.0';


  /// \brief file description for version info
  /// This appears in the user-visible file properties. It is intended to convey publicly
  /// available additional information such as feature builds.
{$IFDEF DEBUG}
  OVR_FILE_DESCRIPTION_STRING = 'dev build debug';
{$ELSE}
  OVR_FILE_DESCRIPTION_STRING = 'dev build';
{$ENDIF}

implementation

end.